#include <iostream>

using namespace std;

int main()
{
    int t, n, m, i, j;
    cin >> t;
    while(t--)
    {
        cin >> n >> m;
        int l[n][m];
        int res[n][m];
        int u[n][m];
        int redovi[n];
        int kolone[m];

        // Unos matrica
        for(i=0; i<n; i++)
        {
            redovi[i]=0;
            for(j=0; j<m; j++)
            {
                cin >> l[i][j];
                kolone[j]=0;
            }
        }
        for(i=0; i<n; i++)
        {
            for(j=0; j<m; j++)
            {
                cin >> u[i][j];
                res[i][j] = 0;
            }
        }
        for(j=0; j<m; j++)
        {
            kolone[j]=0;
        }
        //

        long long int r;
        bool ok = true;

        for(j=0;j<m-1 && ok;j++)
        {
            r = l[0][j]-l[0][j+1];
            for(i=1;i<n;i++)
            {
                if((l[i][j]-l[i][j+1])!=r)
                {
                    ok = false;
                }
            }
        }

        if(ok)
        {
            cout << "Da" << endl;
            for(i=0; i<n; i++)
            {
                for(j=0; j<m; j++)
                {
                    cout << l[i][j] << " ";
                }
                cout << endl;
            }
        }
        else
        {
            cout << "Ne" << endl;
        }
    }
}